Public Class Form1

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Dim AllText As String = "", LineOfText As String = ""
        OpenFileDialog1.Filter = "Textdateien (*.TXT)|*.TXT"
        OpenFileDialog1.ShowDialog() 'ffnen-Dialogfeld anzeigen
        If OpenFileDialog1.FileName <> "" Then
            Try 'Datei ffnen und Fehler mit Handler abfangen
                FileOpen(1, OpenFileDialog1.FileName, OpenMode.Input)
                Do Until EOF(1) 'Zeilen einlesen
                    LineOfText = LineInput(1)
                    'Jede Zeile der Variablen AllText hinzufgen
                    AllText = AllText & LineOfText & vbCrLf
                Loop                   'update label
                lblNotiz.Text = OpenFileDialog1.FileName
                txtNotiz.Text = AllText 'Datei anzeigen
                txtNotiz.Enabled = True 'Textcursor
                CloseToolStripMenuItem.Enabled = True  'Schlieen aktivieren
                OpenToolStripMenuItem.Enabled = False  'ffnen deaktivieren
            Catch
                MsgBox("Fehler beim ffnen der Datei. Sie ist u.U. zu gro.")
            Finally
                FileClose(1) 'Datei schlieen
            End Try
        End If
    End Sub

    Private Sub CloseToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseToolStripMenuItem.Click
        txtNotiz.Text = ""             'Textfeld leeren
        lblNotiz.Text = "Load a text file with the Open command."
        CloseToolStripMenuItem.Enabled = False  'Schlieen deaktivieren
        OpenToolStripMenuItem.Enabled = True    'ffnen aktivieren
    End Sub

    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsToolStripMenuItem.Click
        SaveFileDialog1.Filter = "Textdateien (*.txt)|*.txt"
        SaveFileDialog1.ShowDialog()
        If SaveFileDialog1.FileName <> "" Then
            FileOpen(1, SaveFileDialog1.FileName, OpenMode.Output)
            PrintLine(1, txtNotiz.Text) 'Text auf Datentrger speichern
            FileClose(1)
        End If
    End Sub

    Private Sub InsertDateToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InsertDateToolStripMenuItem.Click
        txtNotiz.Text = My.Computer.Clock.LocalTime & vbCrLf & txtNotiz.Text
        txtNotiz.Select(1, 0)  'Auswahl lschen
    End Sub

    Private Sub SortTextToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SortTextToolStripMenuItem.Click
        Dim ln, curline, letter As String
        Dim i, charsInFile, lineCount As Short

        'Anzahl Zeilen im Textfeld ermitteln(txtNotiz)
        lineCount = 0 'Diese Variable speichert die Gesamtzeilenzahl
        charsInFile = txtNotiz.Text.Length 'Zeichenzahl ermitteln
        For i = 0 To charsInFile - 1 'Text zeichenweise verarbeiten
            letter = txtNotiz.Text.Substring(i, 1) 'Buchstaben lesen
            If letter = Chr(13) Then 'Falls Wagenrcklaufzeichen vorliegt
                lineCount += 1 'zur nchsten Zeile gehen (Zhler erhhen)
                i += 1 'Zeilenvorschub bergehen (folgt stets nach Wagenrcklauf)
            End If
        Next i

        'Array erstellen, in dem  Text aus dem Textfeld gespeichert wird
        ReDim strArray(lineCount) 'Gre des Arrays festlegen
        curline = 1
        ln = "" 'mit ln Zeilen zeichenweise erstellen
        For i = 0 To charsInFile - 1 'Text erneut durchlaufen
            letter = txtNotiz.Text.Substring(i, 1) 'Buchstabe lesen
            If letter = Chr(13) Then 'Falls Wagenrcklaufzeichen vorliegt
                curline = curline + 1 'Zhler um 1 erhhen
                i += 1 'Zeilenvorschub bergehen
                ln = "" 'Zeile aus Variable lschen und zur nchsten Zeile gehen
            Else
                ln = ln & letter 'Buchstabe in Variable ln einfgen
                strArray(curline) = ln 'und an Array bergeben
            End If
        Next i

        'Array sortieren
        ShellSort(strArray, lineCount)

        'Sortiertes Array im Textfeld anzeigen
        txtNotiz.Text = ""
        curline = 1
        For i = 1 To lineCount
            txtNotiz.Text = txtNotiz.Text & _
              strArray(curline) & vbCrLf
            curline += 1
        Next i
        txtNotiz.Select(1, 0)   'Textauswahl aufheben
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        End
    End Sub

    Private Sub MenuStrip1_ItemClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles MenuStrip1.ItemClicked

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
